local PetBattleTeams = LibStub("AceAddon-3.0"):GetAddon("PetBattleTeams")
local GUI = PetBattleTeams:GetModule("GUI")
local TeamManager =  PetBattleTeams:GetModule("TeamManager")
local ROW_HEIGHT = 55
local Cursor = PetBattleTeams:GetModule("Cursor")

local function OnDragStart(self)
	if self:IsMovable() then 
		self:StartMoving()
	end
end

local function OnDragStop(self)
	self:StopMovingOrSizing()
end



local function SELECTED_TEAM_CHANGED(self,event,teamIndex)
	self.selectedTeam:SetTeam(teamIndex)
end


--/run GUI:SetAttached(true)
function GUI:SetAttached(enabled)
	if enabled then
		self.mainFrame:SetPoint("TOPLEFT",PetJournal,"TOPRIGHT",-3,0)
		self.mainFrame:SetParent(PetJournal)
		self.mainFrame:SetMovable(false)
		
	else
		self.mainFrame:SetPoint("TOPLEFT",UIParent)
		self.mainFrame:SetParent(UIParent)
		self.mainFrame:SetMovable(true)
	end
	self.mainFrame.resizer:SetShown(not enabled)
end

function GUI:IsAttached()
	return self.mainFrame:GetParent() == PetJournal
end

function GUI:CreateMainFrame()
	local name = "PetBattleTeamFrame"
	local widget = CreateFrame("frame",name,UIParent)
	widget:SetClampedToScreen(true)
	widget:SetFrameStrata("MEDIUM")
	widget:SetToplevel(true) 
	widget:RegisterForDrag("LeftButton")
	widget:SetSize(165,ROW_HEIGHT*8+166)
	widget:SetMaxResize(widget:GetWidth(),ROW_HEIGHT*11+150)
	widget:SetMinResize(widget:GetWidth(),ROW_HEIGHT*4+150)
	widget:SetMovable(true)
	widget:EnableMouse(true)
	
	--widget:SetSize(114+12,38+10)
	--local height = 
	
	widget:SetBackdrop({
      bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
      edgeFile="Interface\\LFGFRAME\\LFGBorder", 
      tile=1, tileSize=16, edgeSize=16, 
      insets={left=5, right=5, top=5, bottom=5}
	  })
	  
	  
	local selectedTeamText = widget:CreateFontString(nil,"OVERLAY","GameFontNormal")
	widget.selectedTeamText = selectedTeamText
	selectedTeamText:SetText("Selected Team")
	selectedTeamText:SetPoint("TOP", widget, "TOP",-5,-10)
	selectedTeamText:SetJustifyH("CENTER")
	selectedTeamText:Show()
	
	local selectedTeam = PetBattleTeamsFrame:New()
	local h = selectedTeamText:GetHeight()
	selectedTeam:SetPoint("TOPLEFT",widget,"TOPLEFT",0,-h-10)
	
	selectedTeam:SetParent(widget)
	selectedTeam:SetTeam(TeamManager:GetSelected())
	Cursor.UnregisterCallback(selectedTeam,"BATTLE_PET_CURSOR_CHANGED")
	widget.selectedTeam = selectedTeam
	

	
	widget.SELECTED_TEAM_CHANGED = SELECTED_TEAM_CHANGED
	TeamManager.RegisterCallback(widget,"SELECTED_TEAM_CHANGED")
	
	local addTeamButton = self:CreateAddTeamButton("AddTeamButton",widget)
	widget.addTeamButton = addTeamButton
	addTeamButton:SetPoint("BOTTOMLEFT",widget,"BOTTOMLEFT",10,10)
	

	local rosterFrame = self:CreateScrollBar(widget)
	rosterFrame:SetParent(widget)
	rosterFrame:SetPoint("TOPLEFT",selectedTeam,"BOTTOMLEFT",0,0)
	rosterFrame:SetPoint("BOTTOM",addTeamButton,"TOP",0,0)
	widget.rosterFrame = rosterFrame
	
	local resizer = self:CreateResizer(widget)
	widget.resizer = resizer
	resizer:SetPoint("BOTTOMRIGHT",widget,"BOTTOMRIGHT",-5,5)

	--[[local reviveButton = self:CreateReviveButton("ReviveTeamButton",widget)
	widget.reviveButton = reviveButton
	reviveButton:SetPoint("TOPLEFT",addTeamButton,"TOPRIGHT",1,0)]]
	
	widget:SetScript("OnDragStart",OnDragStart)
	widget:SetScript("OnDragStop",OnDragStop)
	
	return widget
end